section .text

; void __stdcall set8087cw(uint16_t);
global _set8087cw@4
_set8087cw@4:
	lea eax, [esp + 4]
	fnclex
	fldcw [eax]
	ret 4

; uint16_t __stdcall get8087cw(void);
global _get8087cw@0
_get8087cw@0:
	push eax
	fnstcw [esp]
	pop eax
	ret

; void __stdcall storet0(long double *);
global _storet0@4
_store0@4:
	mov eax, [esp + 4]
	fldz
	fstp tword [eax]
	ret 4

; void __stdcall storet1(long double *);
global _storet1@4
_store1@4:
	mov eax, [esp + 4]
	fld1
	fstp tword [eax]
	ret 4

; void __stdcall storetpi(long double *);
global _storetpi@4
_storetpi@4:
	mov eax, [esp + 4]
	fldpi
	fstp tword [eax]
	ret 4

; void __stdcall storetd(long double *, double const *);
global _storetd@8
_storetd@8:
	mov edx, [esp + 8]
	mov eax, [esp + 4]
	fld qword [edx]
	fstp tword [eax]
	ret 8

; void __stdcall storedt(double *, long double const *);
global _storedt@8
_storedt@8:
	mov edx, [esp + 8]
	mov eax, [esp + 4]
	fld tword [edx]
	fstp qword [eax]
	ret 8

;int __stdcall comparet(long double const *, long double const *);
global _comparet@8
_comparet@8:
	mov edx, [esp + 8]
	mov eax, [esp + 4]
	fld tword [edx]
	fld tword [eax]
	fcompp
	fnstsw ax
	sahf
	seta al
	setb dl
	sub al, dl
	cbw
	cwde
	ret 8

;void __stdcall chst(long double *, long double const *);
global _chst@8
_chst@8:
	mov edx, [esp + 8]
	mov eax, [esp + 4]
	fld tword [edx]
	fchs
	fstp tword [eax]
	ret 8

;void __stdcall abst(long double *, long double const *);
global _abst@8
_abst@8:
	mov edx, [esp + 8]
	mov eax, [esp + 4]
	fld tword [edx]
	fabs
	fstp tword [eax]
	ret 8

;void __stdcall addt(long double *, long double const *, long double const *);
global _addt@12
_addt@12:
	mov eax, [esp + 8]
	mov edx, [esp + 12]
	fld tword [eax]
	fld tword [edx]
	mov eax, [esp + 4]
	faddp st1, st0
	fstp tword [eax]
	ret 12

;void __stdcall subt(long double *, long double const *, long double const *);
global _subt@12
_subt@12:
	mov eax, [esp + 8]
	mov edx, [esp + 12]
	fld tword [eax]
	fld tword [edx]
	mov eax, [esp + 4]
	fsubp st1, st0
	fstp tword [eax]
	ret 12

;void __stdcall mult(long double *, long double const *, long double const *);
global _mult@12
_mult@12:
	mov eax, [esp + 8]
	mov edx, [esp + 12]
	fld tword [eax]
	fld tword [edx]
	mov eax, [esp + 4]
	fmulp st1, st0
	fstp tword [eax]
	ret 12

;void __stdcall divt(long double *, long double const *, long double const *);
global _divt@12
_divt@12:
	mov eax, [esp + 8]
	mov edx, [esp + 12]
	fld tword [eax]
	fld tword [edx]
	mov eax, [esp + 4]
	fdivp st1, st0
	fstp tword [eax]
	ret 12
